// 19b-threads-01.c, 64 Bit
//
// Systemprogrammierung, SS 2013
// Hans-Georg Esser

#define _GNU_SOURCE 1
#include <signal.h>
#include <ucontext.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#define get_esp(v) __asm__ ("mov %%rsp, %0" : "=r"(v))

#define QUANTUM   100000     // Quantum in mikrosec. fuer Scheduler
#define STACKSIZE 0x4000     // Groesse des Thread-Stacks

int tid = -1;                // Thread-ID, am Anfang noch kein Thread
unsigned long addresses[2];  // Aktuelle RIP-Werte
unsigned long start[2];      // Start-RIP-Werte
unsigned long rsps[2];       // Stack-Pointer
unsigned long rbps[2];       // Base-Pointer

// Thread-Funktionen
void test01 () {
  long int count;
  for (;;) {
    printf ("HALLO WELT [%ld] -- TESTFUNKTION\n", count++);
    usleep (10000);
  };
}

void test02 () {
  long int count;
  for (;;) {
    printf ("hallo welt [%ld] -- zweiter test\n", count++);
    usleep (10000);
  };
}

// Signal-Handler
static void timer_handler(int sig, siginfo_t *si, void *ptr) {
  ucontext_t *uc = (ucontext_t *)ptr;
  
  // Aktuelle Werte (alter Thread) auslesen
  unsigned long rip = uc->uc_mcontext.gregs[REG_RIP];
  unsigned long rsp = uc->uc_mcontext.gregs[REG_RSP];
  unsigned long rbp = uc->uc_mcontext.gregs[REG_RBP];
  printf ("\nrip: %lx, rsp: %lx, rbp: %lx\n", rip, rsp, rbp);
  
  // RIP, RSP, RBP sichern
  if (tid != -1) {   // falls schon ein Thread lief

    // TO DO: Aktuelle Werte rip, rsp, rbp in die richtigen
    //        Array-Positionen (addresses, rsps, rbps)
    //        schreiben

  }
  
  // Neuen Thread auswaehlen (es gibt nur TIDs 0, 1)
  if (tid != -1)
    tid = 1-tid;   // abwechselnd 0, 1
  else
    tid = 0;       // mit Thread 0 starten (Wert war -1)
  printf ("Setze tid auf %d. ", tid);
  
  // rip setzen
  rip = addresses[tid];
  if (rip == 0ul) {
    // Wenn hier 0 steht, Wert aus start[] verwenden
    printf ("Starte Thread %d. ", tid);
    rip = start[tid];
  }
     
  printf ("Neue Adresse: %lx, rsp: %lx, rbp: %lx\n", rip, rsps[tid], rbps[tid]);
  
  // Werte in uc_mcontext eintragen
  
  // TO DO: Wie beim Auslesen; diesmal rip, rsps[tid] und rbps[tid] an die
  //        richtigen Eintraege in gregs schreiben

}

int main() {
  // Werte fuer Threads initialisieren
  void *stack0;   // Stack fuer Thread 0
  void *stack1;   // und Thread 1
  
  // TO DO: Platz fuer Stacks allozieren (-> stack0, stack1)
  
  // TO DO: Stack-Startadresse in rsps[i] und rbps[i] speichern
  //        (Achtung: Der Stack faengt "oben" an!)

  // TO DO: start[i] und addresses[i] mit den Adressen von test01, test02 init.


  // Alarm-Signal-Handler eintragen
  struct sigaction s;
  s.sa_flags = 0;
  s.sa_sigaction = timer_handler;
  sigemptyset(&s.sa_mask);
  sigaction(SIGALRM, &s, NULL);

  // Timer setzen
  struct itimerval timer;
  timer.it_value.tv_sec     = 0;
  timer.it_value.tv_usec    = QUANTUM;
  timer.it_interval.tv_sec  = 0;
  timer.it_interval.tv_usec = QUANTUM;
  setitimer (ITIMER_REAL, &timer, NULL);

  // Endlosschleife
  for (;;) ;
}
